#!/usr/bin/python
# -*- coding=utf-8 -*-
# using WSDL from SOAPpy

import sys
reload(sys)
sys.setdefaultencoding('utf8')
from SOAPpy import WSDL
import base64

mantisIp = sys.argv[1]
userName = sys.argv[2]
password = sys.argv[3]
projectName = sys.argv[4]
category = sys.argv[5]
summary = sys.argv[6]
description = sys.argv[7]
hasAttachment = sys.argv[8]
email = sys.argv[9]

# The location of wsdl file for Mantis Server
wsdlFile = mantisIp+'/api/soap/mantisconnect.php?wsdl'
server = WSDL.Proxy(wsdlFile)

# Following two sentences are debug options 
# server.soapproxy.config.dumpSOAPOut = 1
# server.soapproxy.config.dumpSOAPIn = 1
"""
for i in range(0, server.methods.keys().__len__()):
	print
	b = server.methods.keys()[i]
	print "Function Name:", b
	callinfo = server.methods[b]
	for arg in callinfo.inparams:
		print "Params:", arg.name.ljust(15), arg.type

	for arg in callinfo.outparams:
		print "Return Value:", arg.name.ljust(15), arg.type		
"""
# Follow two sentences are used to demo mc_login function with User name and Password. 
# If the first sentence with wrong password is used, the login will be denied.
# The second sentence will be OK with the right password.     

#server.mc_issue_add("zouyapeng", "123456",{'id':12345,'project':{'id':1,'name':"hello"},'category':'any','summary':"cosfeedback",'description':"It is fault"})
# server.mc_login("shisong", "pass")

#argv[1] mantisIP
#argv[2] summary
#argv[3] description
#argv[4] attachment
#argv[5] Email&score
if __name__=="__main__":
	if len(sys.argv)<5:
                print "Usage:"+sys.argv[0]+"summary description attachment Email"
		sys.exit(-1)
		
	else:
                issue_id = server.mc_issue_add(userName,password,{'project':{'name':projectName},'category':category,'summary':summary,'description':description,'additional_information':email,'severity':{'id':'40'},'reproducibility':{'name':'always'}})
		if (hasAttachment== "true"):
			print "screenshot exists"
			screenshot= open('/tmp/screenshot.jpg')
			try:
				content= screenshot.read()
			finally:
				screenshot.close()
			content_64 = base64.encodestring(content)
			server.mc_issue_attachment_add(userName,password,issue_id,"截图.jpg","",content_64)
	print "over"
	sys.exit(0)
			
